const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Job_requisitionsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const job_requisitions = await db.job_requisitions.create(
      {
        id: data.id || undefined,

        title: data.title || null,
        employment_type: data.employment_type || null,
        openings: data.openings || null,
        status: data.status || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await job_requisitions.setRecruiter(data.recruiter || null, {
      transaction,
    });

    await job_requisitions.setOrganizations(data.organizations || null, {
      transaction,
    });

    return job_requisitions;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const job_requisitionsData = data.map((item, index) => ({
      id: item.id || undefined,

      title: item.title || null,
      employment_type: item.employment_type || null,
      openings: item.openings || null,
      status: item.status || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const job_requisitions = await db.job_requisitions.bulkCreate(
      job_requisitionsData,
      { transaction },
    );

    // For each item created, replace relation files

    return job_requisitions;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const job_requisitions = await db.job_requisitions.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.title !== undefined) updatePayload.title = data.title;

    if (data.employment_type !== undefined)
      updatePayload.employment_type = data.employment_type;

    if (data.openings !== undefined) updatePayload.openings = data.openings;

    if (data.status !== undefined) updatePayload.status = data.status;

    updatePayload.updatedById = currentUser.id;

    await job_requisitions.update(updatePayload, { transaction });

    if (data.recruiter !== undefined) {
      await job_requisitions.setRecruiter(
        data.recruiter,

        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await job_requisitions.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return job_requisitions;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const job_requisitions = await db.job_requisitions.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of job_requisitions) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of job_requisitions) {
        await record.destroy({ transaction });
      }
    });

    return job_requisitions;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const job_requisitions = await db.job_requisitions.findByPk(id, options);

    await job_requisitions.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await job_requisitions.destroy({
      transaction,
    });

    return job_requisitions;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const job_requisitions = await db.job_requisitions.findOne(
      { where },
      { transaction },
    );

    if (!job_requisitions) {
      return job_requisitions;
    }

    const output = job_requisitions.get({ plain: true });

    output.applications_requisition =
      await job_requisitions.getApplications_requisition({
        transaction,
      });

    output.recruiter = await job_requisitions.getRecruiter({
      transaction,
    });

    output.organizations = await job_requisitions.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.employees,
        as: 'recruiter',

        where: filter.recruiter
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.recruiter
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  user: {
                    [Op.or]: filter.recruiter
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.title) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('job_requisitions', 'title', filter.title),
        };
      }

      if (filter.openingsRange) {
        const [start, end] = filter.openingsRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            openings: {
              ...where.openings,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            openings: {
              ...where.openings,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.employment_type) {
        where = {
          ...where,
          employment_type: filter.employment_type,
        };
      }

      if (filter.status) {
        where = {
          ...where,
          status: filter.status,
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.job_requisitions.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('job_requisitions', 'title', query),
        ],
      };
    }

    const records = await db.job_requisitions.findAll({
      attributes: ['id', 'title'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['title', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.title,
    }));
  }
};
